#
#   5B - Level view
#

from pygame import Rect
from pygame.locals import *
from albow.widget import Widget
from vector_algebra import Point2, IdentTran2
import settings

class LevelView(Widget):

	bg_color = (0, 0, 0)

	def __init__(self, rect, game):
		Widget.__init__(self, rect)
		self.game = game

	level = property(lambda self: self.game.current_level)
	
	def draw(self, surf, selection = None, highlight_color = None):
		level = self.level
		t = self.global_to_screen_transformation()
		self.draw_with_transform(surf, t, False)
	
	def draw_with_transform(self, surf, t, with_selection):
		level = self.level
		for part in level.parts:
			part.draw(surf, t)
			part.draw_connections(surf, t)
			if with_selection and part in level.selection:
				part.draw_highlight(surf, t, self.highlight_color)
		for wire in level.wires:
			wire.draw(surf, t)

	def global_to_screen_transformation(self):
		return IdentTran2

	def screen_to_global_transformation(self):
		return IdentTran2

#	def find_clicked_item(self, e, parts_only = False, wires_only = False):
#		p = self.mouse_to_global(e)
#		return self.level.find_item(p, parts_only, wires_only)
	
	def mouse_to_global(self, e):
		t = self.screen_to_global_transformation()
		return t * Point2(e.local)
